/*****************************************************************************
 * Copyright (c) 2021 CEA LIST and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *  Vincent Lorenzo (CEA LIST) vincent.lorenzo@cea.fr - Initial API and implementation
 *
 *****************************************************************************/

package org.eclipse.papyrus.model2doc.integration.emf.documentstructuretemplate.types.internal.advices;

/**
 * Constants used by this plugin of ElementTypes
 */
public final class DocumentTemplateElementTypesConstants {

	private DocumentTemplateElementTypesConstants() {
		// to prevent instantiation
	}

	/**
	 * The Papyrus Element Type Context
	 */
	public static final String PAPYRUS_ELEMENT_TYPE_CONTEXT = "org.eclipse.papyrus.infra.services.edit.TypeContext"; //$NON-NLS-1$

	/**
	 * The Moedl2Doc Element Type Set ID
	 */
	public static final String DOCUMENT_TEMPLATE_ELEMENT_TYPE_SET_ID = "org.eclipse.papyrus.model2doc.integration.emf.documentstructuretemplate.types.elementTypeSet"; //$NON-NLS-1$
}
